; NomadSync.nsi
;
; This script is based on example1.nsi, but it remember the directory, 
; has uninstall support and (optionally) installs start menu shortcuts.
;
; It will install NomadSync.exe into a directory that the user selects,

;--------------------------------

; The name of the installer
Name "NomadSync"

; The file to write
OutFile "NomadSync.exe"

; The default installation directory
InstallDir $PROGRAMFILES\NomadSync

; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM "Software\NSIS_NomadSync" "Install_Dir"

;--------------------------------

; Pages

Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------

; The stuff to install
Section "NomadSync"

  SectionIn RO
  
  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  
  ; Put file there
  File "Release\NomadSync.exe"
  
  ; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\NSIS_NomadSync "Install_Dir" "$INSTDIR"
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\NomadSync" "DisplayName" "NSIS NomadSync"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\NomadSync" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\NomadSync" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\NomadSync" "NoRepair" 1
  WriteUninstaller "uninstall.exe"
  
SectionEnd

; Optional section (can be disabled by the user)
Section "Start Menu Shortcuts"

  CreateDirectory "$SMPROGRAMS\NomadSync"
  CreateShortCut "$SMPROGRAMS\NomadSync\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\NomadSync\NomadSync.lnk" "$INSTDIR\NomadSync.exe" "" "$INSTDIR\NomadSync.exe" 0
  
SectionEnd

;--------------------------------

; Uninstaller

Section "Uninstall"
  
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\NomadSync"
  DeleteRegKey HKLM SOFTWARE\NSIS_NomadSync



  ; Remove files and uninstaller
  Delete $INSTDIR\NomadSync.exe
  Delete $INSTDIR\uninstall.exe

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\NomadSync\*.*"

  ; Remove directories used
  RMDir "$SMPROGRAMS\NomadSync"
  RMDir "$INSTDIR"

SectionEnd