#include "Precompiled.h"
// Note: these can only be defined in the file that uses	CLSID_CTJukeBox2
// don't know why!
#include <Objbase.h>
#include <initguid.h>
#include "WNomad.h"
#include "Track.h"
#include "Playlist.h"

BSTR GetBSTRFromCharString(const char *szString);
wxString GetStringFromBSTR(BSTR bstrString);
unsigned char* SetAttribute(unsigned char* ptr, wxString strData, long dataval, 	
	wxString strLabel, short type, unsigned char** pData = NULL);



Nomad::Nomad() : m_bConnected(false), m_pJukeBox(NULL)
{
	// to do: use defines instead!
	m_mapErrorReason[DAPSDK_SUCCESS] = "";							
	m_mapErrorReason[0x01] = "failed";							
	m_mapErrorReason[0x02] = "device busy";					
	m_mapErrorReason[0x03] = "storage full";					
	m_mapErrorReason[0x05] = "settime rejected";				
	m_mapErrorReason[0x14] = "item size missing";
	m_mapErrorReason[0x18] = "item upload denied";
	m_mapErrorReason[0x80] = "player not connected";
	m_mapErrorReason[0x81] = "cancelled";						
	m_mapErrorReason[0x82] = "port unavailable";				
	m_mapErrorReason[0x83] = "out of memory";					
	m_mapErrorReason[0x84] = "fileopen err";					
	m_mapErrorReason[0x85] = "item_not_found";					
	m_mapErrorReason[0x86] = "load_components_failed";			
	m_mapErrorReason[0x87] = "id_invalid";						
	m_mapErrorReason[0x88] = "filetype_illegal";				
	m_mapErrorReason[0x89] = "loadres_fail";					
	m_mapErrorReason[0x8a] = "format_not_found";				
	m_mapErrorReason[0x8b] = "file_already_exists";			
	m_mapErrorReason[0x8c] = "lib_corrupted";					
	m_mapErrorReason[0x8d] = "lib_busy";						
	m_mapErrorReason[0x8e] = "FILE_READ_WRITE_FAILED";
	m_mapErrorReason[0x8f] = "invalid_filepath";				
	m_mapErrorReason[0x91] = "unsupported";					
	m_mapErrorReason[0x95] = "norights";						
	m_mapErrorReason[0xff] = "undefined_err";					
	m_mapErrorReason[0x04] = "hd_general_error";				
	m_mapErrorReason[0x10] = "track_not_found";				
	m_mapErrorReason[0x11] = "track_already_exist";			
	m_mapErrorReason[0x12] = "track_title_missing";			
	m_mapErrorReason[0x13] = "track_codec_missing";			
	m_mapErrorReason[0x15] = "track_io_operation_aborted";		
	m_mapErrorReason[0x16] = "track_read_write_error";			
	m_mapErrorReason[0x17] = "track_not_opened";				
	m_mapErrorReason[0x20] = "playlist not found";					
	m_mapErrorReason[0x21] = "playlist already exists";				
	m_mapErrorReason[0x22] = "playlist item not found";				
	m_mapErrorReason[0x23] = "playlist item already exists";			
	m_mapErrorReason[0x90] = "diskfull_for_download";			
	m_mapErrorReason[0x06] = "status_timeout";					
	m_mapErrorReason[0x30] = "end_of_track";					
	m_mapErrorReason[0x31] = "end_of_list";					
	m_mapErrorReason[0x32] = "codec_not_supported";			
	m_mapErrorReason[0x33] = "data_corrupted";					
	m_mapErrorReason[0x34] = "sampling_rate_not_supported";	
	m_mapErrorReason[0x35] = "decoding_error";					
	m_mapErrorReason[0x36] = "position_outof_range";			
	m_mapErrorReason[0x37] = "not_stopped";					
	m_mapErrorReason[0x40] = "unknow_property";				
	m_mapErrorReason[0x41] = "value_outof_range";				
	m_mapErrorReason[0x60] = "data_file_not_found";			
	m_mapErrorReason[0x61] = "data_file_too_big";				
	m_mapErrorReason[0x62] = "data_file_already_exist";		
	m_mapErrorReason[0x63] = "too_many_data_files";			
	m_mapErrorReason[0x92] = "wmdm_init_failed";				
	m_mapErrorReason[0x93] = "invalid_argument";				
	m_mapErrorReason[0x94] = "parentnode_not_exist";			
	m_mapErrorReason[0x95] = "norights";						
	m_mapErrorReason[0x96] = "path_excess_len";				
	m_mapErrorReason[0x97] = "load_proc_failed";				
	m_mapErrorReason[0x0100] = "pmsman_createdirectory_failed";	
	m_mapErrorReason[0x0200] = "device_write_failed";			
	m_mapErrorReason[0x0300] = "device_read_failed";				
	m_mapErrorReason[0x0400] = "db_invalid_request_id";			
	m_mapErrorReason[0x0500] = "db_invalid_node_id";				
	m_mapErrorReason[0x0600] = "dwnthrd_createmetadata_failed";	
	m_mapErrorReason[0x0700] = "devinfo_invalid_index";			
	m_mapErrorReason[0x0800] = "invalid_devicesettingtype";		
	m_mapErrorReason[0x0900] = "filesize_too_big";				
	m_mapErrorReason[0x0A00] = "audiofile_format";				
	m_mapErrorReason[0x0B00] = "audiofile_invalid";				
	m_mapErrorReason[0x0C00] = "access_denied";					
	m_mapErrorReason[0x0D00] = "file_not_found";					
	m_mapErrorReason[0x0E00] = "eof";							
	m_mapErrorReason[0x0F00] = "cookie";							
	m_mapErrorReason[0x1000] = "playback_inprogress";			
	m_mapErrorReason[0x1100] = "transfer_inprogress";			
	m_mapErrorReason[0x1200] = "buffer_not_enough";				
}

Nomad::~Nomad()
{
	if(m_pJukeBox != NULL)
	{
		m_pJukeBox->ShutDown2();
		m_pJukeBox->Release();
	}
	CoUninitialize();
}

bool Nomad::InitJukeBox()
{
	if (m_bConnected) return true;
	CoInitialize(NULL);
	if (m_pJukeBox == NULL)
	{
		m_nLastError = CoCreateInstance(CLSID_CTJukeBox2, NULL, CLSCTX_INPROC_SERVER,
			IID_ICTJukebox2, (void**)&m_pJukeBox);
		if (m_nLastError != DAPSDK_SUCCESS) return false;
	}
	m_nLastError = m_pJukeBox->Initialize2();
	if (m_nLastError != DAPSDK_SUCCESS) return false;
	long lCount;
	m_pJukeBox->GetDeviceCount2(&lCount);
	if (lCount == 0) return false;
	DAPSDK_ID itemRoot;
	m_nLastError = m_pJukeBox->FindFirstRootItem(1, (IUnknown*)&itemRoot);
	wxString str;
	while (m_nLastError == DAPSDK_SUCCESS)
	{
		str = GetStringFromBSTR(itemRoot.bstrName);
		if (str == "PLAY LISTS") 
		{
			m_itemIDPlaylists = itemRoot;
		}
		m_nLastError = m_pJukeBox->FindNextRootItem(1, (IUnknown*)&itemRoot);
	}
	m_bConnected = true;
	return true;
}

Playlist* Nomad::GetFirstPlaylist()
{
	if (!m_bConnected) return false;
	DAPSDK_ID itemIDPlaylist;
	m_hrPrevSeek = m_pJukeBox->FindFirstParentItem(1, (IUnknown*)&m_itemIDPlaylists, 
		(IUnknown*)&itemIDPlaylist);
	if (m_hrPrevSeek != DAPSDK_SUCCESS && m_hrPrevSeek != DAPSDK_E_ITEM_NOT_FOUND)
		m_nLastError = m_hrPrevSeek;
	if (m_hrPrevSeek != DAPSDK_SUCCESS)	return NULL;
	Playlist* pPlaylist = new Playlist;
	pPlaylist->SetItemID((unsigned int)itemIDPlaylist.lID);
	pPlaylist->SetName(GetStringFromBSTR(itemIDPlaylist.bstrName));
	return pPlaylist;
}	//	GetFirstPlaylist

Playlist* Nomad::GetNextPlaylist()
{
	if (!m_bConnected) return false;
	if (m_hrPrevSeek != DAPSDK_SUCCESS) return NULL;
	DAPSDK_ID itemIDPlaylist;
	m_hrPrevSeek = m_pJukeBox->FindNextParentItem(1, (IUnknown*)&m_itemIDPlaylists, 
		(IUnknown*)&itemIDPlaylist);
	if (m_hrPrevSeek != DAPSDK_SUCCESS && m_hrPrevSeek != DAPSDK_E_ITEM_NOT_FOUND)
		m_nLastError = m_hrPrevSeek;
	if (m_hrPrevSeek != DAPSDK_SUCCESS)	return NULL;
	Playlist* pPlaylist = new Playlist;
	pPlaylist->SetItemID((unsigned int)itemIDPlaylist.lID);
	pPlaylist->SetName(GetStringFromBSTR(itemIDPlaylist.bstrName));
	return pPlaylist;
}

bool Nomad::GetPlaylistTracks()
{
	if (!m_bConnected) return false;
	PlaylistMap::const_iterator iterMapPl; 
	map<unsigned int, Track*>::iterator iterMapTrack;
	HRESULT hr = DAPSDK_SUCCESS;
	bool bFirst;
	DAPSDK_ID itemPlaylist;
	itemPlaylist.lType = kPlaylistType;
	for (iterMapPl = m_mapPlaylist.begin(); iterMapPl != m_mapPlaylist.end(); iterMapPl++) 
	{
		bFirst = true;
		do
		{
			itemPlaylist.lID = (long)iterMapPl->second->GetItemID();
			if (bFirst)
			{
				hr = m_pJukeBox->FindFirstItem(1, 
					(IUnknown*)&itemPlaylist, (IUnknown*)&m_itemID);
				bFirst = false;
			}
			else
				hr = m_pJukeBox->FindNextItem(1, 
					(IUnknown*)&itemPlaylist, (IUnknown*)&m_itemID);
			if (hr != DAPSDK_SUCCESS)	break;
			iterMapTrack = m_mapTrack.find((unsigned int)m_itemID.lID); 
			if (iterMapTrack == m_mapTrack.end()) 
			{
				wxLogMessage("Unknown track in playlist: %s!",
					(const char*)GetStringFromBSTR(m_itemID.bstrName));
			}
			else iterMapPl->second->Add(iterMapTrack->second);
		} while(true);
		if (hr != DAPSDK_E_ITEM_NOT_FOUND)
		{
			m_nLastError = hr;
			wxLogMessage("Error: %s, in playlist: %s!", (const char*)GetErrorStr(hr),
				(const char*)iterMapPl->second->GetName()); 
		}
	}	// end for playlist
	return m_nLastError == DAPSDK_SUCCESS;
}


bool Nomad::SendPlaylist(Playlist* pPlaylist)
{
	//delete current playlist
	if (pPlaylist->GetItemID() != 0)
	{
		DAPSDK_ID itemID;
		itemID.lID = (long)pPlaylist->GetItemID();
		itemID.lType = kPlaylistType;
		m_nLastError = m_pJukeBox->DeleteParentItem (1, (IUnknown*)&itemID);
		if (m_nLastError != DAPSDK_SUCCESS) return false;
	}
	DAPSDK_ID itemNewID;
	itemNewID.lType = kPlaylistType;
	itemNewID.bstrName = GetBSTRFromCharString(pPlaylist->GetName());

	// Create the new playlist, empty but with the same name as the old one.
	m_nLastError = m_pJukeBox->AddParentItem(1, (IUnknown*)&m_itemIDPlaylists, 
		(IUnknown*)&itemNewID);
	if (m_nLastError != DAPSDK_SUCCESS) return false;
	pPlaylist->SetItemID((unsigned int)itemNewID.lID);
	TrackList& listTrack = pPlaylist->GetNomadListTrack();
	unsigned char *pBuf = new unsigned char[listTrack.size()*sizeof(DAPSDK_ID)];
	unsigned char *pCurr = pBuf;
	unsigned int n;
	DAPSDK_ID itemTemp;
	itemTemp.lType = kAudioTrackType;
	for (n = 0; n < listTrack.size(); n++)
	{
		itemTemp.lID = (long)listTrack[n]->GetItemID();
		memcpy(pCurr, &itemTemp, sizeof(DAPSDK_ID));
		pCurr += sizeof(DAPSDK_ID);
	}
	m_nLastError = m_pJukeBox->AddItemsToParentItem(1, (IUnknown*)&itemNewID, 
		listTrack.size(), (IUnknown*)pBuf);
	delete [] pBuf;
	return m_nLastError == DAPSDK_SUCCESS;
}	// SendPlaylist


bool Nomad::DeleteItem(const Playlist* pPlaylist)
{
	//delete current playlist
	if (pPlaylist->GetItemID() == 0) return false;
	DAPSDK_ID itemID;
	itemID.lID = (long)pPlaylist->GetItemID();
	itemID.lType = kPlaylistType;
	m_nLastError = m_pJukeBox->DeleteParentItem (1, (IUnknown*)&itemID);
	if (m_nLastError != DAPSDK_SUCCESS) return false;
	return true;
}	// DeleteItem


bool Nomad::StartLoadAllTracks()
{
	if (!m_bConnected) return false;
	RemoveTracks();
	m_itemIDParent.lID = ALLTRACKSKEY;
	m_itemIDParent.lType = kAudioTrackType;
	m_hrPrevSeek = m_pJukeBox->FindFirstItem(1, (IUnknown*)&m_itemIDParent, 
		(IUnknown*)&m_itemID);
	if (m_hrPrevSeek != DAPSDK_SUCCESS && m_hrPrevSeek != DAPSDK_E_ITEM_NOT_FOUND)
		m_nLastError = m_hrPrevSeek;
	return m_hrPrevSeek == DAPSDK_SUCCESS;
}


bool Nomad::MoveNextTrack()
{
	if (!m_bConnected) return false;
	if (m_hrPrevSeek == DAPSDK_SUCCESS)
	{
		m_hrPrevSeek = m_pJukeBox->FindNextItem(1, (IUnknown*)&m_itemIDParent, 
			(IUnknown*)&m_itemID);
		if (m_hrPrevSeek != DAPSDK_SUCCESS && m_hrPrevSeek != DAPSDK_E_ITEM_NOT_FOUND)
			m_nLastError = m_hrPrevSeek;
	}
	return m_hrPrevSeek == DAPSDK_SUCCESS;
}


Track* Nomad::LoadTrackData()
{
	if (!m_bConnected) return false;
	long inSize, outSize;
	unsigned char *buf;
	// Get Attribute buffer size.
	m_nLastError = m_pJukeBox->GetItemAttribute(1, (IUnknown*)&m_itemID, 0, &outSize, NULL);
	if (m_nLastError != DAPSDK_SUCCESS || outSize <= 0)
	{
		wxLogMessage("Error can't read track: %s!", 
			(const char*)GetStringFromBSTR(m_itemID.bstrName));
		return NULL;
	}
	inSize = outSize;
	buf = new unsigned char[outSize];

	// Get Attribute buffer content.
	m_nLastError = m_pJukeBox->GetItemAttribute(1, (IUnknown*)&m_itemID, inSize, &outSize, 
		(IUnknown*)buf);
	if (m_nLastError != DAPSDK_SUCCESS)
	{
		wxLogMessage("Error can't read track: %s!", 
			(const char*)GetStringFromBSTR(m_itemID.bstrName));
		delete [] buf;
		return NULL;
	}
	unsigned char*	ptr = buf;
	short nCount = 0;
	short type = 0;
	short nLen = 0;
	long nDataLen = 0;
	int nValue = 0;
	wxString strLabel, strValue;
	char *psz;
	Track* pTrack = new Track;
	pTrack->SetItemID((unsigned int)m_itemID.lID);
	// Get number of attributes.
	memcpy(&nCount, ptr, sizeof(short));
	if (nCount <= 5)
	{
		wxLogMessage("Warning track with only %d attributes!", nCount);
	}
	ptr += sizeof(short);
	for (int i = 0; i < nCount; i++)
	{
		memcpy(&type, ptr, sizeof(short));
		if (type != kASCII && type != kUNICODE && type != kBINARY)
		{
			pTrack->SetAttrib(taTitle, GetStringFromBSTR(m_itemID.bstrName));
			wxLogMessage("Faulty track: %s!", 
				(const char*)pTrack->GetDisplayName());
			pTrack->SetFaulty(true);	
			pTrack->SetAttrib(taArtist, "Faulty track!!");
			pTrack->SetAttrib(taCodec, "mp3");
			pTrack->SetAttrib(taAlbum, wxString::Format("%d", m_itemID.lID));
			delete [] buf;
			AddTrack(pTrack);
			return pTrack;
		}
		ptr += sizeof(short);
		memcpy(&nLen, ptr, sizeof(short));
		if (nLen < 0) break;
		ptr += sizeof(short);
		memcpy(&nDataLen, ptr, sizeof(long));
		if (nDataLen < 0) break;
		ptr += sizeof(long);
		psz = strLabel.GetWriteBuf(nLen+1);
		memcpy(psz, ptr, nLen);
		psz[nLen] = '\0';
		strLabel.UngetWriteBuf();
		ptr += nLen;
		if (type == kASCII)
		{
			strValue = (char*)ptr;
			strValue[nDataLen/sizeof(char)] = '\0';
		}
		if (type == kUNICODE)
		{
			strValue = (wchar_t*)ptr;
			strValue.Truncate(nDataLen/sizeof(wchar_t));
		}
		if (type == kBINARY && (nDataLen == 4 || nDataLen == 2))
		{
			nValue = 0;
			memcpy(&nValue, ptr, nDataLen);
		}
		if (strLabel.CmpNoCase("PLAYONLY") == 0 && nValue)
		{
			wxLogMessage("Protected track ignored: %s!", 
				(const char*)pTrack->GetDisplayName());
			AddTrack(pTrack);
			delete [] buf;
			return NULL;
		}
		if (type == kBINARY && (nDataLen != 4 && nDataLen != 2))
		{
			wxLogMessage("Track %s, Label %s has unexpected length!", 
				(const char*)pTrack->GetDisplayName(), strLabel);
		}
		else 
		{
			if (strLabel.CmpNoCase("PLAYONLY") != 0) 
				SetTrackAttrib(pTrack, strLabel, strValue, nValue);
		}
		ptr += nDataLen;
	}	// end for 
	delete [] buf;
	AddTrack(pTrack);
	return pTrack;
}	// GetCurrTrackData



bool Nomad::DeleteItem(const Track* pTrack)
{
	if (!m_bConnected) return false;
	DAPSDK_ID itemID;
	itemID.lID = (long)pTrack->GetItemID();
	itemID.lType = kAudioTrackType;
	m_nLastError = m_pJukeBox->DeleteItem(1, (IUnknown*)&itemID);
	return m_nLastError == DAPSDK_SUCCESS;
}

bool Nomad::SetCallback(long hWnd)
{
	m_nLastError = m_pJukeBox->SetCallbackWindow2(1, hWnd);
	return m_nLastError == DAPSDK_SUCCESS;
}


bool Nomad::GetItem(const Track* pTrack, wxFileName& fileSpec)
{
	DAPSDK_ID itemID;
	itemID.lID = (long)pTrack->GetItemID();
	itemID.lType = kAudioTrackType;
	BSTR bstrFile = GetBSTRFromCharString(fileSpec.GetFullPath());
	m_nLastError = m_pJukeBox->GetItem(1, bstrFile, (IUnknown*)&itemID);
	SysFreeString(bstrFile);
	return m_nLastError == DAPSDK_SUCCESS;
}


bool Nomad::SendItem(Track* pTrack)
{
	unsigned char *buf, *ptr, *pNewTrackID;
	short nCount;
	int nSize = 2; /*count*/
	for (int n = 1; n < c_nAttribNames; n++)
	{
		nSize += 2/*type*/+6/*namelen+datalen*/ + c_nAttribName[n].Length();
		if (n >= taFileSize)
			nSize += sizeof(long);
		else
			nSize += pTrack->GetFilledAttrib(n).Length();
	}
	nSize += 2+6+strlen(TRACKID)+sizeof(long); // buffer to receive the duplicate track ID
	buf = new unsigned char[nSize];
	memset(buf, 0, nSize);
	// fill up buffer with tag info
	ptr = buf;
	nCount = 10;
	memcpy(ptr, &nCount, sizeof(short));
	ptr += sizeof(short);
	ptr = SetAttribute(ptr, pTrack->GetFilledAttrib(taTitle), 0, TITLE, kASCII);
	ptr = SetAttribute(ptr, pTrack->GetFilledAttrib(taAlbum), 0, ALBUM, kASCII);
	ptr = SetAttribute(ptr, pTrack->GetFilledAttrib(taArtist), 0, ARTIST, kASCII);
	ptr = SetAttribute(ptr, pTrack->GetFilledAttrib(taGenre), 0, GENRE, kASCII);
	ptr = SetAttribute(ptr, "", pTrack->GetTrackLength(), LENGTH, kBINARY);
	ptr = SetAttribute(ptr, "", pTrack->GetTrackNum(), TRACKNUM, kBINARY);
	ptr = SetAttribute(ptr, "", pTrack->GetYear(), YEAR, kBINARY);
	ptr = SetAttribute(ptr, "", pTrack->GetFileSize(), FILESIZE, kBINARY);
	ptr = SetAttribute(ptr, pTrack->GetFilledAttrib(taCodec), 0, CODEC, kASCII);
		// require the duplicate track id 
		// if the track already existing in device
	long lDupTrackID = 0;
	SetAttribute(ptr, "", lDupTrackID, TRACKID, kBINARY, &pNewTrackID);
	BSTR bstrFileName = GetBSTRFromCharString(pTrack->GetAttrib(taFileSpec));
	m_nLastError = m_pJukeBox->AddItem(1, kAudioTrackType, bstrFileName, nSize, (IUnknown*)buf);
	delete [] buf;
	SysFreeString(bstrFileName);
	return m_nLastError == DAPSDK_SUCCESS;
}

bool Nomad::SendLabel(const Track* pTrackPC, const Track* pTrackNomad)
{
	unsigned char *buf;
	long nSize;
	int nAttrib;
	BSTR bstrAttribName;
	DAPSDK_ID itemID;
	itemID.lType = kAudioTrackType;
	wxString strAttrib;
	for (nAttrib = taTitle; nAttrib <= taGenre; nAttrib++)
	{
		if (pTrackPC->GetAttrib((trackAttribStr)nAttrib) 
			!= pTrackNomad->GetAttrib((trackAttribStr)nAttrib))
		{
			strAttrib = pTrackPC->GetFilledAttrib(nAttrib);
			nSize = strAttrib.Length();
			buf = new unsigned char[nSize];
			memcpy(buf, strAttrib, nSize);
			bstrAttribName = GetBSTRFromCharString(c_nAttribName[nAttrib]);
			itemID.lID = (long)pTrackNomad->GetItemID();
			m_nLastError = m_pJukeBox->SetItemAttribute(1, (IUnknown*)&itemID, 
				bstrAttribName, kASCII, nSize, (IUnknown*)buf);
			delete [] buf;
			SysFreeString(bstrAttribName);
			if (m_nLastError != DAPSDK_SUCCESS) return false;
		}
	}
	if (pTrackPC->GetTrackNum() != 0 &&
		pTrackPC->GetTrackNum() != pTrackNomad->GetTrackNum() )
	{
		SetBinaryAttrib((DWORD)pTrackPC->GetTrackNum(), c_nAttribName[taTrackNum], 
			(long)pTrackNomad->GetItemID());
		if (m_nLastError != DAPSDK_SUCCESS) return false;
	}
	if (pTrackPC->GetYear() != 0 &&
		pTrackPC->GetYear() != pTrackNomad->GetYear() )
	{
		SetBinaryAttrib((DWORD)pTrackPC->GetYear(), c_nAttribName[taYear], 
			(long)pTrackNomad->GetItemID());
		if (m_nLastError != DAPSDK_SUCCESS) return false;
	}
	return m_nLastError == DAPSDK_SUCCESS;
}

void Nomad::SetBinaryAttrib(DWORD nData, const wxString& strAttribName, long nID)
{
	DAPSDK_ID itemID;
	itemID.lType = kAudioTrackType;
	BSTR bstrAttribName;
	unsigned char *buf;

	buf = new unsigned char[sizeof(DWORD)];
	memcpy(buf, &nData, sizeof(DWORD));
	bstrAttribName = GetBSTRFromCharString(strAttribName);
	itemID.lID = nID;
	m_nLastError = m_pJukeBox->SetItemAttribute(1, (IUnknown*)&itemID, 
		bstrAttribName, kBINARY, sizeof(DWORD), (IUnknown*)buf);
	if (m_nLastError == DAPSDK_E_UNSUPPORTED)
	{
		wxLogMessage("Cannot download year or track number label. Please Upgrade Driver!");
		m_nLastError = DAPSDK_SUCCESS;	// suppress error
	}
	delete [] buf;
	SysFreeString(bstrAttribName);
}

bool Nomad::IsUnicodeSupported()
{
	long lLangEnc = 0;
	//Unicode supported in FW 3.00 and above
	if (m_pJukeBox->GetDeviceProperties(1, kLangEncodeSupport, (IUnknown*)&lLangEnc) 
		== DAPSDK_SUCCESS && lLangEnc & 0x80000000) return true;
	return false; 
}

void Nomad::CancelTransfer()
{
	m_nLastError = m_pJukeBox->CancelTransfer2(1);
}

wxString Nomad::GetLastErrorStr() const
{
	return GetErrorStr(m_nLastError);
}

wxString Nomad::GetErrorStr(HRESULT hr) const
{
	wxString strErr;
	map<int, wxString>::const_iterator iterMap; 
	iterMap = m_mapErrorReason.find(hr); 
	if (iterMap != m_mapErrorReason.end())
	{
		strErr = iterMap->second;
	}
	else
	{
		strErr = "Unknown error code";
	}
	return strErr;
}


unsigned char* SetAttribute(unsigned char* ptr, wxString strData, long dataval, 	
	wxString strLabel, short type, unsigned char** pData)
{
	WORD namelen;
	DWORD datalen;
	memcpy(ptr, &type, sizeof(WORD));

	ptr += sizeof(WORD);
	namelen = (WORD)strLabel.Length();
	memcpy(ptr, &namelen, sizeof(WORD));

	ptr += sizeof(WORD);
	if(type == kBINARY)
		datalen = 4;
	else if (type == kASCII)
		datalen = strData.Length();
	else	// kUNICODE
		datalen = strData.Length() * sizeof(wchar_t);
	memcpy(ptr, &datalen, sizeof(DWORD));
	ptr += sizeof(DWORD);

	memcpy(ptr, strLabel, namelen);
	ptr += namelen;
	if (pData != NULL) *pData = ptr;

	if(type == kBINARY)
		memcpy(ptr, &dataval, datalen);
	else if (type == kASCII)
		memcpy(ptr, strData, datalen);
	ptr += datalen;
	return ptr;
}

wxString GetStringFromBSTR(BSTR bstrString)
{
	wxString str;
	// get length of string
	WORD wCount = (WORD) SysStringLen(bstrString);
	char *psz = str.GetWriteBuf(wCount+1);
	WideCharToMultiByte(CP_ACP, 
						0, (wchar_t*)bstrString,
						-1, psz,	wCount, NULL, NULL);
	psz[wCount] = '\0';
	str.UngetWriteBuf();
	::SysFreeString(bstrString); //release memory
	return str;
}

BSTR GetBSTRFromCharString(const char *szString)
{
	wchar_t wszString[MAX_PATH];
	MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, szString, lstrlen(szString)+1, 
		wszString, MAX_PATH);
	return SysAllocString( wszString );
}

