#ifndef _NOMAD_H_INCLUDED_
#define _NOMAD_H_INCLUDED_
#include <nmsdk.h>

#include "BaseNomad.h"
using namespace std;

class Track;

class Nomad	: public BaseNomad
{
public:
	Nomad();
	virtual ~Nomad();
	virtual bool InitJukeBox();
	virtual bool StartLoadAllTracks();
	virtual bool MoveNextTrack();
	virtual Track* LoadTrackData();
	virtual bool SendItem(Track* pTrack);
	virtual bool GetItem(const Track* pTrack, 
		wxFileName& fileSpec);
	virtual bool DeleteItem(const Track* pTrack);
	virtual bool DeleteItem(const Playlist* pPlaylist);
	bool SetCallback(long hWnd);
	virtual void CancelTransfer();
	bool IsUnicodeSupported();
	virtual wxString GetLastErrorStr() const;
	wxString GetErrorStr(HRESULT hr) const;
	virtual bool SendLabel(const Track* pTrackPC, 
		const Track* pTrackNomad);
	virtual Playlist* GetNextPlaylist();
	virtual Playlist* GetFirstPlaylist();
	virtual bool SendPlaylist(Playlist* pPlaylist);
	virtual bool GetPlaylistTracks();
private:
	void SetBinaryAttrib(DWORD nData, const wxString& strAttribName, long nID);

	ICTJukebox2* m_pJukeBox;	
	HRESULT m_hrPrevSeek;
	DAPSDK_ID m_itemIDParent;
	DAPSDK_ID m_itemID;
	DAPSDK_ID m_itemIDPlaylists;
	bool m_bConnected;
	map<int, wxString> m_mapErrorReason;
};





#endif // _NOMAD_H_INCLUDED_
